import_dll kernel32.dll

	import_func ExitProcess
	import_func GetCommandLine alias GetCommandLineA
	import_func GetModuleHandle alias GetModuleHandleA

import_dll user32.dll

	import_func CreateWindowEx alias CreateWindowExA
	import_func DefWindowProc alias DefWindowProcA
	import_func DispatchMessage alias DispatchMessageA
	import_func GetMessage alias GetMessageA
	import_func LoadCursor alias LoadCursorA
	import_func LoadIcon alias LoadIconA
	import_func PostQuitMessage
	import_func RegisterClassEx alias RegisterClassExA
	import_func ShowWindow
	import_func TranslateMessage
	import_func UpdateWindow

include Window.inc

section ".text"  class_code
section ".data"  class_data
section ".idata" class_imports
section "reloc" class_relocs

..data
ClassName   db "SimpleWinClass",0
AppName     db "Our First Window",0
align 4
hInstance   dd ?
wc          WNDCLASSEX ?
msg         MSG ?

.entry _start

..text

_start:
	mov	eax,WndProc

    invoke  GetModuleHandle,0
    mov     [hInstance],eax
    invoke  GetCommandLine
    invoke  WinMain,[hInstance],NULL,eax,SW_SHOWDEFAULT
    invoke  ExitProcess,eax

PROC WinMain
USES esi
ARG hInst,hPrevInst,CmdLine,CmdShow

    LOCAL hwnd
    mov     esi,wc
    mov     [esi+WNDCLASSEX.cbSize],WNDCLASSEX
    mov     [esi+WNDCLASSEX.style],CS_HREDRAW+CS_VREDRAW
nop
    mov     [esi+WNDCLASSEX.lpfnWndProc],WndProc
nop

    mov     [esi+WNDCLASSEX.cbClsExtra],NULL
    mov     [esi+WNDCLASSEX.cbWndExtra],NULL
    push    [hInstance]
    pop     [esi+WNDCLASSEX.hInstance]
    mov     [esi+WNDCLASSEX.hbrBackground],COLOR_WINDOW+1
    mov     [esi+WNDCLASSEX.lpszMenuName],NULL
    mov     [esi+WNDCLASSEX.lpszClassName],ClassName
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     [esi+WNDCLASSEX.hIcon],eax
    mov     [esi+WNDCLASSEX.hIconSm],eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     [esi+WNDCLASSEX.hCursor],eax
    invoke  RegisterClassEx,wc
    invoke  CreateWindowEx,NULL,ClassName,AppName,\
            WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
            CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,[hInst],NULL
    mov     [hwnd],eax
    invoke  ShowWindow,[hwnd],SW_SHOWNORMAL
    invoke  UpdateWindow,[hwnd]

_loop:

    invoke  GetMessage,msg,NULL,0,0
    test    eax,eax
    jz      exit_loop
    invoke  TranslateMessage,msg
    invoke  DispatchMessage,msg
    jmp     _loop

exit_loop:

    mov     eax,[msg+MSG.wParam]
    ret

ENDP

PROC WndProc
ARG hWnd,uMsg,wParam,lParam

    .IF [uMsg] == WM_DESTROY
        invoke PostQuitMessage,NULL
    .ELSE
        invoke DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]
        ret
    .ENDIF
    xor eax,eax
    ret
ENDP
